<?php

include('finance.php');
include('bills.php');

if(array_key_exists('Operation', $_GET)) $Operation = $_GET['Operation']; else $Operation = '';
switch($Operation)
{
  case 'NewPaymentInsert':
    $Output = ShowNewPaymentInsert();  
    break;
  case 'NewPaymentForm':
    $Output = ShowNewPaymentForm();  
    break;
  case 'NewInvoiceForm':
    $Output = ShowNewInvoiceForm();  
    break;
  default:
    $Output = '<a href="?Operation=NewPaymentForm">Přidat novou platbu</a><br>';
    $Output .= '<a href="?Operation=NewInvoiceForm">Přidat novou fakturu</a><br>';
}
echo(FormatOutput($Output));

function CheckAdvancesAndLiabilities($Subject)
{
  global $Database, $LastInsertTime;
  do {
    $DbResult = $Database->select('FinanceAdvances', 'SUM(Value)', 'Subject='.$Subject.' AND Direction = "In"');
    $DbRow = $DbResult->fetch_array();
    $Advances = $DbRow[0];
    $DbResult = $Database->select('FinanceClaimsLiabilities', '*', 'Subject='.$Subject.' AND TimePayment IS NULL AND Value > 0 ORDER BY TimeCreation LIMIT 1');
    //echo($Database->error);
    if($DbResult->num_rows > 0)
    {
      $OpenedClaim = $DbResult->fetch_array();
      if($Advances > $OpenedClaim['Value'])
      {
        $Database->update('FinanceClaimsLiabilities', 'Id='.$OpenedClaim['Id'], array('TimePayment' => TimeToMysqlDateTime($LastInsertTime)));
        $Database->insert('FinanceAdvances', array('Subject' => $OpenedClaim['Subject'], 'Value' => -$OpenedClaim['Value'], 'TimeCreation' => TimeToMysqlDateTime($LastInsertTime), 'CashFlowId' => $OpenedClaim['Id'], 'Direction' => 'In'));
        //echo($Database->LastQuery);
      } else break;
    } else break;
  } while(($Advances > $OpenedClaim['Value']));
}

function InsertLiability($Subject, $Value, $Time, $BillId, $Text, $TimePayment = '')
{
  global $Database, $LastInsertTime;
  if($TimePayment != '') $TimePayment = TimeToMysqlDateTime($TimePayment);
  $Database->insert('FinanceClaimsLiabilities', array('Text' => $Text, 'Subject' => $Subject, 'TimeCreation' => TimeToMysqlDateTime($Time), 'TimeDue' => TimeToMysqlDateTime($Time + 3600*24*15), 'TimePayment' => $TimePayment, 'Value' => $Value, 'Bill' => $BillId));
  echo($Database->LastQuery.'<br>');
  $LastInsertTime = $Time;
  CheckAdvancesAndLiabilities($Subject);
}

function InsertMoney($Subject, $Value, $Cash, $Taxable, $Time, $Text)
{
  global $Database, $LastInsertTime;
  $Database->insert('FinanceCashFlow', array('Text' => $Text, 'Subject' => $Subject, 'Cash' => $Cash, 'Value' => $Value, 'Time' => TimeToMysqlDateTime($Time), 'Taxable' => $Taxable));
  if($Value >= 0)
  {
    $Database->insert('FinanceAdvances', array('Subject' => $Subject, 'Value' => $Value, 'TimeCreation' => TimeToMysqlDateTime($Time), 'CashFlowId' => $Database->insert_id, 'Direction' => 'In'));
  }
  $LastInsertTime = $Time;
  CheckAdvancesAndLiabilities($Subject);
}

function ShowNewPaymentForm()
{ 
  global $Database;
  $Values = array();
  $Output = '<form action="?Operation=NewPaymentInsert" method="post">'.ShowEditTable('NewPayment', $Values);
  $Output .= '<input type="submit" value="Vložit"></form>';
  return($Output); 
}

function ShowNewPaymentInsert()
{
  global $Database;
  $Values = LoadSubmitedData('NewPayment');
  InsertMoney($Values['Subject'], $Values['Value'], $Values['Cash'], $Value['Taxable'], $Values['Text'], time());
  echo('Nová platba vložena');
  //echo(phpinfo());
}

function ShowNewInvoiceForm()
{ 
  global $Database;
  $Values = array();
  $Output = '<form action="?Operation=NewInvoiceInsert" method="post">'.ShowEditTable('NewInvoice', $Values);
  $Output .= '<input type="submit" value="Vložit"></form>';
  return($Output); 
}

function ImportOldData()
{
  global $Database, $InvoiceGenerator;

  $Database->query('TRUNCATE TABLE FinanceCashFlow');
  $Database->query('TRUNCATE TABLE FinanceClaimsLiabilities');
  $Database->query('TRUNCATE TABLE FinanceAdvances');
  $Database->query('TRUNCATE TABLE FinanceSmallAssets');

  // Move time of device price transformation 
  $Database->query('UPDATE finance_operations SET date="2007-11-30" WHERE comment = "Jednorázový poplatek za společné zařízení"');

  // Transfer finance before era
  $DbResult = $Database->query('SELECT * FROM users WHERE role=2');
  while($User = $DbResult->fetch_array())
  {
    $DbResult2 = $Database->query('SELECT SUM(money) FROM finance_operations WHERE user='.$User['id'].' AND date < "2007-12-01"');
    $Row = $DbResult2->fetch_array();
    $TotalAdvance = $Row[0];
    //echo($User['second_name'].' '.$User['first_name'].' '.$TotalAdvance.'<br>');
    // Záloha
    if($TotalAdvance > 0) 
    {
      InsertMoney($User['id'], $TotalAdvance, 0, 1, mktime(0, 0, 0, 12, 1, 2007), 'Přijatá záloha (z období před daňovou evidencí)');
    }
    // Dluh
    if($TotalAdvance < 0) 
    {  
      InsertLiability($User['id'], (-$Row[0]), mktime(0, 0, 0, 12, 1, 2007), 0, 'Připojení k síti (z období před daňovou evidencí)');
      //echo($Database->LastQuery.'<br>');
    }
  }  

  // Transfer finance after era
//  $DbResult = $Database->query('SELECT * FROM users WHERE role=2');
//  while($User = $DbResult->fetch_array())
//  {
    $DbResult2 = $Database->query('SELECT finance_operations.*, users.role as role FROM finance_operations JOIN users ON users.id = finance_operations.user WHERE finance_operations.date >= "2007-12-01"');
    while($Operation = $DbResult2->fetch_array())
    {
      //echo($Operation['comment'].'<br>');
      if(substr($Operation['comment'], 0, 19) == 'Poplatek za měsíc')
      {
        InsertLiability($Operation['user'], -$Operation['money'], MysqlDateToTime($Operation['date']), $Operation['bill_id'], 'Připojení k síti');
        echo($Operation['user'].' '.$Operation['money'].' Připojení k síti<br>');
      } else
      if($Operation['comment'] == 'Vklad')
      {
        InsertMoney($Operation['user'], $Operation['money'], 0, 1, MysqlDateToTime($Operation['date']), 'Přijatá záloha');
        //echo($Operation['user'].' '.$Operation['money'].' Přijatá záloha<br>');
      } else
      if($Operation['comment'] == 'Internet')
      {
        InsertLiability($Operation['user'], $Operation['money'], MysqlDateToTime($Operation['date']), $Operation['bill_id'], 'Měsíční paušál za Internet', MysqlDateToTime($Operation['date']));
        InsertMoney($Operation['user'], $Operation['money'], 0, 1, MysqlDateToTime($Operation['date']), 'Měsíční paušál za Internet');
      } else
      if($Operation['comment'] == 'Sociální pojištění')
      {
        InsertLiability($Operation['user'], $Operation['money'], MysqlDateToTime($Operation['date']), $Operation['bill_id'], $Operation['comment'], MysqlDateToTime($Operation['date']));
        InsertMoney($Operation['user'], $Operation['money'], 0, 1, MysqlDateToTime($Operation['date']), $Operation['comment']);
      } else
      {
        $DbResult = $Database->query('SELECT role FROM users WHERE id='.$Operation['user']);
        while($User = $DbResult->fetch_array())
       
        InsertLiability($Operation['user'], -$Operation['money'], MysqlDateToTime($Operation['date']), $Operation['bill_id'], $Operation['comment'], MysqlDateToTime($Operation['date']));
        echo($Operation['user'].' '.$Operation['comment'].' '.MysqlDateToTime($Operation['date']).'<br>');

        if(($Operation['role'] == 2))
        { 
          echo('A');
          $Database->insert('FinanceAdvances', array('Subject' => $Operation['user'], 'Value' => $Operation['money'], 'TimeCreation' => MysqlDateToTime($Operation['date']), 'CashFlowId' => 0, 'Direction' => 'In'));
          CheckAdvancesAndLiabilities($Operation['user']);
        } else InsertMoney($Operation['user'], $Operation['money'], 0, 1, MysqlDateToTime($Operation['date']), $Operation['comment']);
      }
    }
//  }

  // Import small asset
  $Subject = 1;

  // Převod pro minulý rok
  $Time = mktime(0, 0, 0, 12, 10, 2007);
  $DbResult = $Database->query('SELECT * FROM network_devices WHERE used <> 0 AND date < "'.TimeToMysqlDateTime($Time).'" AND (id <> 73)');
  $Items = array();
  $TotalPrice = 0;
  while($Device = $DbResult->fetch_array())
  {
    //$Database->insert('FinanceSmallAsset', array());
    $Items[] = array('description' => $Device['name'], 'quantity' => $Device['count'], 'price' => 0); //$Device['price']); 
    $LastId = $Device['id'];
    $TotalPrice += $Device['price'] * $Device['count'];
    if($TotalPrice > 55000) break;
  }
  //print_r($Items);
  $BillId = $InvoiceGenerator->CreateBill($Subject, $Items, $Time, $Time);
  $DbResult = $Database->query('UPDATE network_devices SET TimeEnlistment = "'.TimeToMysqlDateTime($Time).'" WHERE used <> 0 AND date < "'.TimeToMysqlDateTime($Time).'" AND (id <> 73) AND (id <= '.$LastId.')');
  //echo($Database->error);
  InsertLiability($Subject, 0, $Time, $BillId, 'Nákup infrastruktury', $Time);
  //InsertMoney($Subject, 0, 0, 1, $Time, 'Nákup infrastruktury');

  //echo($LastId);

  // Převod tento rok
  $Time = mktime(0, 0, 0, 1, 14, 2008);
  $DbResult = $Database->query('SELECT * FROM network_devices WHERE (used <> 0) AND (id > '.$LastId.') AND date < "'.TimeToMysqlDateTime($Time).'"');
  $Items = array();
  $TotalPrice = 0;
  while($Device = $DbResult->fetch_array())
  {
    //$Database->insert('FinanceSmallAsset', array());
    $Items[] = array('description' => $Device['name'], 'quantity' => $Device['count'], 'price' => 0); //$Device['price']);
    $TotalPrice += $Device['price'] * $Device['count'];
  }
  //print_r($Items);
  $BillId = $InvoiceGenerator->CreateBill($Subject, $Items, $Time, $Time);
  $DbResult = $Database->query('UPDATE network_devices SET TimeEnlistment = "'.TimeToMysqlDateTime($Time).'" WHERE used <> 0 AND date < "'.TimeToMysqlDateTime($Time).'" AND (id > '.$LastId.')');
  InsertLiability($Subject, 0, $Time, $BillId, 'Nákup infrastruktury', $Time);
  //InsertMoney($Subject, 0, 0, 1, $Time, 'Nákup infrastruktury');


  // Make absolute value in monthly overall  
  //$Database->query('UPDATE finance_monthly_overall SET total_paid = ABS(total_paid)');
  //$Database->query('UPDATE finance_monthly_overall SET member_count = (SELECT COUNT(*) FROM users WHERE users.role=2 AND users.membership_date < finance_monthly_overall.date)');
}

ImportOldData();

?>